summaryrefslogtreecommitdiffstats
path: root/client/shared/scripts/ogRestaurarSoftIncremental
diff options
context:
space:
mode:
authorramon <ramongomez@us.es>2013-01-29 12:13:09 +0000
committerramon <ramongomez@us.es>2013-01-29 12:13:09 +0000
commitd843835d77f48ec87e367951e343ebdfcc662ba9 (patch)
tree28d3a1a8859591b950e6c9f37c382e47c78e3d51 /client/shared/scripts/ogRestaurarSoftIncremental
parentf243a47352b8651ca2ec6dec70a546bbdbb2495f (diff)
#565, Alonso: Scripts de creación y restauración de imágenes diferenciales.
git-svn-id: https://opengnsys.es/svn/branches/version1.0@3505 a21b9725-9963-47de-94b9-378ad31fedc9
Diffstat (limited to 'client/shared/scripts/ogRestaurarSoftIncremental')
-rwxr-xr-xclient/shared/scripts/ogRestaurarSoftIncremental185
1 files changed, 185 insertions, 0 deletions
diff --git a/client/shared/scripts/ogRestaurarSoftIncremental b/client/shared/scripts/ogRestaurarSoftIncremental
new file mode 100755
index 00000000..d8c07566
--- /dev/null
+++ b/client/shared/scripts/ogRestaurarSoftIncremental
@@ -0,0 +1,185 @@
+#!/bin/bash
+#___________________________________________________________________
+#
+# RESTAURAR IMAGEN INCREMENTAL
+#___________________________________________________________________
+#
+# Parámetros recibidos desde el cliente:
+#
+# $1 Número de disco
+# $2 Número de particion
+# $3 Nombre canónico de la imagen básica (sin extensión)
+# $4 Dirección del repositorio
+# $5 Nombre canónico del software incremental (sin extensión)
+# $5 Es una cadena "nnnn" tipo flags que codifica varios parametros.
+# Tiene el formato "nnnn" donde "n" vale 0 ó 1.
+# 1XXX: Borrar la particion de destino antes de restaurar la imagen incremental
+# X1XX: Copiar Imagen incremental también a la cache
+# XX1X: Borrar previamente la imagen incremental de la cache antes de copiarla
+# XXX1: No borrar archivos en destino
+# El valor X indica que no importa el valor que tenga el dato
+# $7 Método de clonación 0=Desde caché 1=Desde repositorio
+# $8 Ruta de origen de la Imagen (Carpeta)
+#___________________________________________________________________
+#
+# Control parámetros
+#___________________________________________________________________
+
+ PROG="$(basename $0)"
+ if [ $# -lt 6 ]; then
+ usage=" ndisco nparticion nombre_imagen_basica ip_repositorio copiar_a_caché "
+ usage="$usage Borrar_cache_previamente metodo_clonación Ruta_origen"
+ ogRaiseError $OG_ERR_FORMAT "$MSG_FORMAT: $PROG $usage"
+ exit $?
+ fi
+
+ DISCO=$1
+ NPART=$2
+ NOMBREIMG=$3
+ IPREPOSITORIO=$4
+ NOMBREIMGINC=$5
+
+ flag=$6
+ echo "flah:$flag">/tmp/log
+ BORRARIMG=${flag:0:1}
+ COPIACACHE=${flag:1:1}
+ BORRACACHE=${flag:2:1}
+ NOBORRACHIVOS=${flag:3:1}
+
+ METCLONA=$7
+ RUTAORIGEN=$8
+#___________________________________________________________________
+#
+# Variables y configuración logs
+#___________________________________________________________________
+
+ source /opt/opengnsys/scripts/ImagenesSincronizadas.lib
+
+ if [ -z $SISTEMAFICHERO ]; then
+ case "$TIPOPARTICION" in
+ 7)
+ SISTEMAFICHERO="Windows"
+ ;;
+ 83)
+ SISTEMAFICHERO="Linux"
+ ;;
+ esac
+ fi
+#___________________________________________________________________
+#
+# Proceso
+#___________________________________________________________________
+
+ echo "Restauracion de imagen incremental..." | tee -a $OGLOGSESSION $OGLOGFILE
+
+ # Borrado previo de la partición
+ if [ $BORRARIMG -eq 1 ]; then
+ if [ -n $RUTAORIGEN ]; then
+ echo "Borrando carpeta $PARTICION$RUTAORIGEN" | tee -a $OGLOGSESSION $OGLOGFILE
+ rm -R $PARTICION$RUTAORIGEN
+ else
+ echo "Formateando la particion" | tee -a $OGLOGSESSION $OGLOGFILE
+ ogFormat $DISCO $PARTICION $TIPOPARTICION
+ RETVAL=$?
+ if [ $RETVAL -ne 0 ]; then
+ exit $OG_ERR_PARTITION
+ fi
+ fi
+ fi
+
+ # Sincronización desde repositorio
+ if [ $METCLONA = 1 ]; then
+ if [ $COPIACACHE = 0 ]; then
+ echo "Restaurando imagen basica desde repositorio $IPREPOSITORIO" | tee -a $OGLOGSESSION $OGLOGFILE
+ ORIGEN="$REPOSITORIO/$NOMBREIMG/"
+ DESTINO=$PARTICION$RUTAORIGEN/
+ # Restauración de la imagen básica
+ echo "Sincronizando imagen basica entre $ORIGEN y $DESTINO" | tee -a $OGLOGSESSION $OGLOGFILE
+ restaurarImagen $ORIGEN $DESTINO $SISTEMAFICHERO 1
+ RETVAL=$?
+ if [ $RETVAL -ne 0 ]; then
+ exit $OG_ERR_IMAGE
+ fi
+
+ # Restauración de la imagen incremental
+ echo "Restaurando imagen incremental desde repositorio $IPREPOSITORIO" | tee -a $OGLOGSESSION $OGLOGFILE
+ ORIGEN="$REPOSITORIO/$NOMBREIMGINC/"
+ DESTINO=$PARTICION$RUTAORIGEN/
+ OP_DELETE=""
+ # Restauración de la imagen incremental
+ echo "Sincronizando imagen entre $ORIGEN y $DESTINO" | tee -a $OGLOGSESSION $OGLOGFILE
+ restaurarImagen $ORIGEN $DESTINO $SISTEMAFICHERO 1
+ restauraListaAcl $ORIGEN $DESTINO $SISTEMAFICHERO $DISCO $NPART
+ RETVAL=$?
+ exit $RETVAL
+ fi
+ fi
+
+ # Restauración desde la caché
+ echo "Restaurando desde la cache" | tee -a $OGLOGSESSION $OGLOGFILE
+
+ # Comprobar si existe caché
+ CACHE=$(montaCache)
+ if [ -z $CACHE ]; then
+ echo "No se ha podido restaurar la imagen desde la cache" | tee -a $OGLOGSESSION $OGLOGFILE
+ ogRaiseError $OG_ERR_NOTCACHE "CACHE"
+ exit $?
+ fi
+
+ # Borrar imagen de la caché
+ if [ $BORRACACHE -eq 1 ]; then
+ echo "Borrando imagen basica $NOMBREIMG de la cache" | tee -a $OGLOGSESSION $OGLOGFILE
+ rm -R $CACHE$OGIMG/$NOMBREIMG
+ echo "Borrando imagen incremental $NOMBREIMGINC de la cache" | tee -a $OGLOGSESSION $OGLOGFILE
+ rm -R $CACHE$OGIMG/$NOMBREIMGINC
+ fi
+
+ # Actualización de la caché
+ echo "Actualizando cache local desde repositorio $IPREPOSITORIO" | tee -a $OGLOGSESSION $OGLOGFILE
+
+ ORIGEN="$REPOSITORIO/$NOMBREIMG/"
+ DESTINO="$CACHE$OGIMG/$NOMBREIMG/"
+ echo "Sincronizando imagen basica entre $ORIGEN y $DESTINO" | tee -a $OGLOGSESSION $OGLOGFILE
+ restaurarImagen $ORIGEN $DESTINO $SISTEMAFICHERO 1
+ RETVAL=$?
+ if [ $RETVAL -ne 0 ]; then
+ exit $OG_ERR_IMAGE
+ fi
+ ORIGEN="$REPOSITORIO/$NOMBREIMGINC/"
+ DESTINO="$CACHE$OGIMG/$NOMBREIMGINC/"
+ echo "Sincronizando imagen incremental entre $ORIGEN y $DESTINO" | tee -a $OGLOGSESSION $OGLOGFILE
+ restaurarImagen $ORIGEN $DESTINO $SISTEMAFICHERO 1
+ RETVAL=$?
+ if [ $RETVAL -ne 0 ]; then
+ exit $OG_ERR_IMAGE
+ fi
+
+ # Restauración desde caché a la partición
+
+ echo "Copiando imagen basica a la partición desde cache local" | tee -a $OGLOGSESSION $OGLOGFILE
+ ORIGEN="$CACHE$OGIMG/$NOMBREIMG/"
+ DESTINO=$PARTICION$RUTAORIGEN/
+ echo "Sincronizando imagen entre $ORIGEN y $DESTINO" | tee -a $OGLOGSESSION $OGLOGFILE
+ restaurarImagen $ORIGEN $DESTINO $SISTEMAFICHERO 2
+ RETVAL=$?
+ if [ $RETVAL -ne 0 ]; then
+ exit $OG_ERR_IMAGE
+ fi
+
+ echo "Copiando imagen incremental a la partición desde cache local" | tee -a $OGLOGSESSION $OGLOGFILE
+ ORIGEN="$CACHE$OGIMG/$NOMBREIMGINC/"
+ DESTINO=$PARTICION$RUTAORIGEN/
+ OP_DELETE=""
+ echo "Sincronizando imagen entre $ORIGEN y $DESTINO" | tee -a $OGLOGSESSION $OGLOGFILE
+ restaurarImagen $ORIGEN $DESTINO $SISTEMAFICHERO 2
+ restauraListaAcl $ORIGEN $DESTINO $SISTEMAFICHERO $DISCO $NPART
+ RETVAL=$?
+ if [ $RETVAL -ne 0 ]; then
+ exit $OG_ERR_IMAGE
+ fi
+#___________________________________________________________________
+#
+# Retorno
+#___________________________________________________________________
+
+ exit 0